# language: ru

Функционал: Инициализация каталога исходников конфигурации
    Как Пользователь
    Я хочу создать каталог исходников конфигурации 1С в git-репозитории
    Чтобы выполнять автоматическую выгрузку конфигураций из хранилища

Контекст: Тестовый каталог
  Когда очищаю параметры гитсинк в контексте 
  И я подготовил тестовый каталог
  И я установил тестовый каталог как текущий
  И я подключил каталог тестового хранилища конфигурации

Сценарий: Инициализация каталога исходников в пустом каталоге внутри git-репозитория
    Допустим я создал каталог git-репозитория "git-repo" 
    И установил каталог "git-repo" как текущий
    И я создал каталог исходников
    Когда я передаю путь тестового каталога хранилища конфигурации для запуска gitsync
    И я передаю путь каталога исходников для запуска gitsync
    И я передаю режим отладки "off" для запуска gitsync
    И я выполняю команду gitsync "init"
    Тогда в каталоге исходников создается файл или каталог "AUTHORS"
    И в каталоге исходников создается файл или каталог "VERSION"
    И в каталоге исходников не создается файл или каталог ".git"

Сценарий: Инициализация нового, еще не созданного каталога исходников внутри git-репозитория
    Допустим я создал каталог git-репозитория "git-repo" 
    И установил каталог "git-repo" как текущий
    И я задал путь каталога исходников
    Когда я передаю путь тестового каталога хранилища конфигурации для запуска gitsync
    И я передаю путь каталога исходников для запуска gitsync
    И я выполняю команду gitsync "init"
    Тогда в каталоге исходников создается файл или каталог "AUTHORS"
    И в каталоге исходников создается файл или каталог "VERSION"
    И в каталоге исходников не создается файл или каталог ".git"

Сценарий: Инициализация каталога исходников, не находящегося внутри git-репозитория
    Допустим я создал каталог исходников
    Когда я передаю путь тестового каталога хранилища конфигурации для запуска gitsync
    И я передаю путь каталога исходников для запуска gitsync
    И я выполняю команду gitsync "init"
    Тогда в каталоге исходников создается файл или каталог "AUTHORS"
    И в каталоге исходников создается файл или каталог "VERSION"
    И в каталоге исходников создается файл или каталог ".git"
