﻿///////////////////////////////////////////////////////////////////
//
// Служебный модуль с реализацией работы команды set-version
//
// Представляет собой модификацию приложения gitsync от 
// команды oscript-library
//
// Структура модуля реализована в соответствии с рекомендациями 
// oscript-app-template (C) EvilBeaver
//
///////////////////////////////////////////////////////////////////

Процедура ЗарегистрироватьКоманду(Знач ИмяКоманды, Знач Парсер) Экспорт

	ОписаниеКоманды = Парсер.ОписаниеКоманды(ИмяКоманды, "Устанавливает необходимую версию в файл VERSION");
	
	Парсер.ДобавитьПозиционныйПараметрКоманды(ОписаниеКоманды, "КаталогФайлаВерсии", "Каталог, в котором находится файл VERSION.");
	Парсер.ДобавитьПозиционныйПараметрКоманды(ОписаниеКоманды, "НомерВерсии", "Номер версии для записи в файл.");

	Парсер.ДобавитьИменованныйПараметрКоманды(ОписаниеКоманды, "-debug", "<on|off>");
	Парсер.ДобавитьИменованныйПараметрКоманды(ОписаниеКоманды, "-verbose", "<on|off>");
	
	Парсер.ДобавитьКоманду(ОписаниеКоманды);

КонецПроцедуры // ЗарегистрироватьКоманду

Функция ВыполнитьКоманду(Знач ПараметрыКоманды, Знач ДополнительныеПараметры) Экспорт

	Если Не ЗначениеЗаполнено(ПараметрыКоманды["КаталогФайлаВерсии"]) Тогда

		ВызватьИсключение "Не указан каталог расположения файла версий";

	КонецЕсли;

	Если ПараметрыКоманды["НомерВерсии"] = Неопределено Тогда

		ВызватьИсключение "Не указана устанавливаемая версия";

	КонецЕсли;

	Распаковщик = РаспаковщикКонфигурации.ПолучитьИНастроитьРаспаковщик(ПараметрыКоманды, ДополнительныеПараметры);
	ФайлВерсий = Новый Файл(ОбъединитьПути(ПараметрыКоманды["КаталогФайлаВерсии"], "VERSION"));
	ДополнительныеПараметры.Лог.Отладка("Записываю файл версий: " + ФайлВерсий.ПолноеИмя);
	Распаковщик.ЗаписатьФайлВерсийГит(ФайлВерсий.Путь, ПараметрыКоманды["НомерВерсии"]);

	Возврат МенеджерКомандПриложения.РезультатыКоманд().Успех;

КонецФункции // ВыполнитьКоманду
